Ecore Timer functions

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Macros | Typedefs | Functions
Ecore Timer functions
Ecore » Ecore main loop

Ecore provides very flexible timer functionality. More...

## Typedefs
typedef Eo | Ecore_Timer
| A handle for timers.

## Functions
double | ecore_timer_precision_get (void)
| Retrieves the current precision used by timer infrastructure. More...
void | ecore_timer_precision_set (double precision)
| Sets the precision to be used by timer infrastructure. More...
char * | ecore_timer_dump (void)
Ecore_Timer * | ecore_timer_add (double in, Ecore_Task_Cb func, const void *data)
| Creates a timer to call the given function in the given period of time. More...
Ecore_Timer * | ecore_timer_loop_add (double in, Ecore_Task_Cb func, const void *data)
| Creates a timer to call the given function in the given period of time. More...
void * | ecore_timer_del (Ecore_Timer *timer)
| Delete the specified timer from the timer list. More...
void | ecore_timer_freeze (Ecore_Timer *timer)
Eina_Bool | ecore_timer_freeze_get (Ecore_Timer *timer)
void | ecore_timer_thaw (Ecore_Timer *timer)

## Detailed Description

Ecore provides very flexible timer functionality.

The basic usage of timers, to call a certain function at a certain interval can be achieved with a single line:

Eina_Bool my_func(void *data) {
do_funky_stuff_with_data(data);
return ECORE_CALLBACK_RENEW;
}
ecore_timer_add(interval_in_seconds, my_func, data_given_to_function);

Note
  If the function was to be executed only once simply return `ECORE_CALLBACK_CANCEL` instead.

An example that shows the usage of a lot of these:

- ecore timers - Scheduled events

## Function Documentation

double ecore_timer_precision_get | ( | void |  | ) |

Retrieves the current precision used by timer infrastructure.

Returns
  Current precision.

See also
  ecore_timer_precision_set()

References EINA_MAIN_LOOP_CHECK_RETURN_VAL.

void ecore_timer_precision_set | ( | double | precision | ) |

Sets the precision to be used by timer infrastructure.

Parameters

  precision | allowed introduced timeout delay, in seconds.

This sets the precision for all timers. The precision determines how much of an difference from the requested interval is acceptable. One common reason to use this function is to increase the allowed timeout and thus decrease precision of the timers, this is because less precise the timers result in the system waking up less often and thus consuming less resources.

Be aware that kernel may delay delivery even further, these delays are always possible due other tasks having higher priorities or other scheduler policies.

Example: We have 2 timers, one that expires in a 2.0s and another that expires in 2.1s, if precision is 0.1s, then the Ecore will request for the next expire to happen in 2.1s and not 2.0s and another one of 0.1 as it would before.

Note
  Ecore is smart enough to see if there are timers in the precision range, if it does not, in our example if no second timer in (T + precision) existed, then it would use the minimum timeout.

Examples:
  ecore_timer_example.c.

References EINA_MAIN_LOOP_CHECK_RETURN, and ERR.

Ecore_Timer* ecore_timer_add | ( | double | in,
|  | Ecore_Task_Cb | func,
|  | const void * | data
| ) |  |

Creates a timer to call the given function in the given period of time.

Parameters

  in | The interval in seconds.
  func | The given function. If `func` returns 1, the timer is rescheduled for the next interval `in`.
  data | Data to pass to `func` when it is called.

Returns
  A timer object on success. `NULL` on failure.

This function adds a timer and returns its handle on success and NULL on failure. The function `func` will be called every `in` seconds. The function will be passed the `data` pointer as its parameter.

When the timer `func` is called, it must return a value of either 1 (or ECORE_CALLBACK_RENEW) or 0 (or ECORE_CALLBACK_CANCEL). If it returns 1, it will be called again at the next tick, or if it returns 0 it will be deleted automatically making any references/handles for it invalid.

Examples:
  banshee.c, client.c, complex-types-client-eina-value.c, complex-types-server.c, complex-types.c, ecore_animator_example.c, ecore_exe_example.c, ecore_fd_handler_example.c, ecore_idler_example.c, ecore_thread_example.c, ecore_time_functions_example.c, ecore_timer_example.c, eina_tiler_01.c, evas-events.c, server.c, test_growing_balls.c, and test_rotating_forever.c.

References EINA_MAIN_LOOP_CHECK_RETURN_VAL.

Referenced by ecore_con_url_timeout_set(), and ecore_init().

Ecore_Timer* ecore_timer_loop_add | ( | double | in,
|  | Ecore_Task_Cb | func,
|  | const void * | data
| ) |  |

Creates a timer to call the given function in the given period of time.

Parameters

  in | The interval in seconds from current loop time.
  func | The given function. If `func` returns 1, the timer is rescheduled for the next interval `in`.
  data | Data to pass to `func` when it is called.

Returns
  A timer object on success. `NULL` on failure.

This is the same as ecore_timer_add(), but "now" is the time from ecore_loop_time_get() not ecore_time_get() as ecore_timer_add() uses. See ecore_timer_add() for more details.

void* ecore_timer_del | ( | Ecore_Timer * | timer | ) |

Delete the specified timer from the timer list.

Parameters

  timer | The timer to delete.

Returns
  The data pointer set for the timer when ecore_timer_add was called. `NULL` is returned if the function is unsuccessful.

Note: `timer` must be a valid handle. If the timer function has already returned 0, the handle is no longer valid (and does not need to be delete).

Examples:
  client.c, complex-types-server.c, ecore_fd_handler_example.c, ecore_idler_example.c, ecore_timer_example.c, evas-events.c, test_growing_balls.c, and test_rotating_forever.c.

References EINA_MAIN_LOOP_CHECK_RETURN_VAL.

Referenced by ecore_avahi_del(), ecore_con_url_shutdown(), ecore_con_url_timeout_set(), ecore_shutdown(), and ecore_wl_window_free().